<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html;">
<meta http-equiv="Content-Style-Type" content="text/css">
<title>Fully Modded phpBB :: Compare Language Files</title>
<script language="JavaScript" type="text/javascript">
<!--
	window.status="Fully Modded phpBB :: Compare Language Files"
// -->
</script>
<link rel="stylesheet" href="http://phpbbfm.net/phpBBFM/templates/subSilver/subSilver.css" type="text/css">
<style type="text/css">
<!--
body { background: url(http://phpbbfm.net/phpBBFM/templates/subSilver/images/background.gif) repeat-x; }
-->
</style>
</head>
<body>
<table width="95%" align="center" cellpadding="2" cellspacing="2">
  <tr>
	<td height="110"><a href="_2do_check_lang_files.php"><img src="http://phpbbfm.net/phpBBFM/images/logo_phpBB.gif" border="0"></a></td>
	<td align="center"><span class="headtitle"><i>Comparing Fully Modded Language Files</i></span></td>
  </tr>
</table>
<br />
<table width="50%" align="center" cellpadding="3" cellspacing="1" class="forumline">
  <tr>
	<th class="thHead">Important Announcement</th>
  </tr>
  <tr>
	<td class="row1">Due to some files containing functions, they can not be compared using this script. You will have to manually compare the following files:<br />
	- lang_bid_faq.php<br />
	- lang_main.php<br />
	- lang_admin_pafiledb.php<br />
	</td>
  </tr>
</table>
<br />
<?php
$dirname = './language';
$lang = array();

function format_text($in)
{
	$text = addslashes($in);
	$code_entities_match = array('#<#', '#>#', '#"#', '#:#', '#\[#', '#\]#', '#\(#', '#\)#', '#\{#', '#\}#');
	$code_entities_replace = array('&lt;', '&gt;', '&quot;', '&#58;', '&#91;', '&#93;', '&#40;', '&#41;', '&#123;', '&#125;');
	$text = preg_replace($code_entities_match, $code_entities_replace, $text);
	$text = str_replace("  ", "&nbsp; ", $text);
	// now Replace 2 spaces with " &nbsp;" to catch odd #s of spaces.
	$text = str_replace("  ", " &nbsp;", $text);
	// Replace tabs with "&nbsp; &nbsp;" so tabbed code indents sorta right without making huge long lines.
	$text = str_replace("\t", "&nbsp; &nbsp;", $text);
	return nl2br($text);
}


function compare_files($source_lang, $dest_lang, $file_var)
{
	global $dirname, $lang;


	$lang = array();

	print_r("<table width='100%' cellspacing='1' cellpadding='3' border='0' class='forumline' align='center'><th class='thTop'>Comparing Language File - " . $file_var . ".php</th></tr>");
	print_r("<tr><td class='row1'><span class='maintitle'>- lang_" . $file_var . ".php</span><br />");

	include($dirname . '/' . $source_lang . '/lang_' . $file_var . '.php');

	$lang_entry_src = array();
	$num_entries_src = 0;
	@reset($lang);
	while( list($key, $value) = each($lang) )
	{
		$lang_entry_src['key'][$num_entries_src] = $key;
		$lang_entry_src['value'][$num_entries_src] = $value;
		$num_entries_src++;
	}

	$lang = array();

	print_r("Analizing and comparing to: <b>" . $dest_lang . "/lang_" . $file_var . ".php</b></td></tr><tr><td class='row2'>");

	include($dirname . '/' . $dest_lang . '/lang_' . $file_var . '.php');

	$lang_entry_dst = array();
	$num_entries_dst = 0;
	@reset($lang);
	while( list($key, $value) = each($lang) )
	{
		$lang_entry_dst['key'][$num_entries_dst] = $key;
		$lang_entry_dst['value'][$num_entries_dst] = $value;
		$num_entries_dst++;
	}

	$missing = array();

	// Missing Language Variables
	for ($i = 0; $i < $num_entries_src; $i++)
	{
		if (!in_array($lang_entry_src['key'][$i], $lang_entry_dst['key']))
		{
			$missing['key'][] = $lang_entry_src['key'][$i];
			$missing['value'][] = $lang_entry_src['value'][$i];
		}
	}

	$not_needed = array();

	// Not anymore needed Lang Vars
	for ($i = 0; $i < $num_entries_dst; $i++)
	{
		if (!in_array($lang_entry_dst['key'][$i], $lang_entry_src['key']))
		{
			$not_needed['key'][] = $lang_entry_dst['key'][$i];
			$not_needed['value'][] = $lang_entry_dst['value'][$i];
		}
	}

	// Write down those Lang Vars
	print_r("<b>These Language Variables are <span style='color=#FF0000'>missing</span> from " . $dest_lang . "/lang_" . $file_var .".php</b><br />");
	for ($i = 0; $i < count($missing['key']); $i++)
	{
		print_r("<span class=\"gensmall\">\$lang['" . $missing['key'][$i] . "'] = '" . format_text($missing['value'][$i]) . "';</span><br />");
	}

	print_r("<br /><b>These Language Variables are <span style='color=#FF0000'>no longer needed</span> in " . $dest_lang . "/lang_" . $file_var .".php</b><br />");
	for ($i = 0; $i < count($not_needed['key']); $i++)
	{
		print_r("<span class=\"gensmall\">\$lang['" . $not_needed['key'][$i] . "'] = '" . format_text($not_needed['value'][$i]) . "';</span><br />");
	}
	print_r("</td></tr></table><br />");
}


$dir = opendir($dirname);

while ( $file = readdir($dir) )
{
	if ( ereg("^lang_", $file) && !ereg("^lang_english", $file) && !is_file($dirname . '/' . $file) && !is_link($dirname . '/' . $file) )
	{
		compare_files('lang_english', $file, 'admin');
		compare_files('lang_english', $file, 'faq');
		compare_files('lang_english', $file, 'main');
		compare_files('lang_english', $file, 'bbcode');
	}
}

print_r("<div align='center' class='copyright'>Language Checker by <a href='http://www.opentools.de' target='_blank' class='copyright'>Acyd Burn</a> &copy; 2002, 2003<br />Modified for <a href='http://phpbbfm.net' target='_blank' class='copyright'>Fully Modded</a> by MJ &copy; 2003</div>");

?>