<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html;">
<meta http-equiv="Content-Style-Type" content="text/css">
<title> phpBB :: Compare Language Files</title>
<script language="JavaScript" type="text/javascript">
<!--
	window.status="Verifica lingua (basato su un script originale di phpBBfm.net"
// -->
</script>
<link rel="stylesheet" href="templates/subSilver/subSilver.css" type="text/css">
<style type="text/css">
<!--
body { background: url(templates/subSilver/images/background.gif) repeat-x; }
-->
</style>
</head>
<body>
<table width="95%" align="center" cellpadding="2" cellspacing="2">
  <tr>
	<td height="110"><a href="_2do_check_lang_files.php"><img src="templates/subSilver/images/logo_phpBB.gif" border="0"></a></td>
	<td align="center"><span class="headtitle"><i>Comparazione file di linguaggio</i></span></td>
  </tr>
</table>
<br />
<table width="50%" align="center" cellpadding="3" cellspacing="1" class="forumline">
  <tr>
	<th class="thHead">Avviso</th>
  </tr>
  <tr>
	<td class="row1">A causa della possibile presenza di alcune funzioni potrebbero esserci dei messaggi di errore per le visualizzazioni<br />
	</td>
  </tr>
</table>
<br />
<?php
define('IN_PHPBB', true);
define('IN_SMILIESUPLOAD_LANG', true);
define('IN_PRILLIAN_LANG', true);
define('IN_CONTACT_LANG', true);
// $board_config['default_lang'] =
// $phpEx =
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
$phpEx = 'php';
$dirname = './language';
$lang = array();

function format_text($in)
{
	$text = addslashes($in);
	$code_entities_match = array('#<#', '#>#', '#"#', '#:#', '#\[#', '#\]#', '#\(#', '#\)#', '#\{#', '#\}#');
	$code_entities_replace = array('&lt;', '&gt;', '&quot;', '&#58;', '&#91;', '&#93;', '&#40;', '&#41;', '&#123;', '&#125;');
	$text = preg_replace($code_entities_match, $code_entities_replace, $text);
	$text = str_replace("  ", "&nbsp; ", $text);
	// now Replace 2 spaces with " &nbsp;" to catch odd #s of spaces.
	$text = str_replace("  ", " &nbsp;", $text);
	// Replace tabs with "&nbsp; &nbsp;" so tabbed code indents sorta right without making huge long lines.
	$text = str_replace("\t", "&nbsp; &nbsp;", $text);
	return nl2br($text);
}


function compare_files($source_lang, $dest_lang, $file_var)
{
	global $dirname, $lang;


	$lang = array();

	print_r("<table width='100%' cellspacing='1' cellpadding='3' border='0' class='forumline' align='center'><th class='thTop'>Comparazione file di lingua - " . $file_var . ".php</th></tr>");
	print_r("<tr><td class='row1'><span class='maintitle'>- lang_" . $file_var . ".php</span><br />");

	include($dirname . '/' . $source_lang . '/lang_' . $file_var . '.php');
	$board_config['default_lang'] = $source_lang ;
	$phpbb_root_path = './';
	$phpEx = 'php';
	$lang_entry_src = array();
	$num_entries_src = 0;
	@reset($lang);
	while( list($key, $value) = each($lang) )
	{
		$lang_entry_src['key'][$num_entries_src] = $key;
		$lang_entry_src['value'][$num_entries_src] = $value;
		$num_entries_src++;
	}

	$lang = array();

	print_r("Analizing and comparing to: <b>" . $dest_lang . "/lang_" . $file_var . ".php</b></td></tr><tr><td class='row2'>");
	
	include($dirname . '/' . $dest_lang . '/lang_' . $file_var . '.php');
	$board_config['default_lang'] = $dest_lang ;
	$phpbb_root_path = './';
	$phpEx = 'php';
		
	$lang_entry_dst = array();
	$num_entries_dst = 0;
	@reset($lang);
	while( list($key, $value) = each($lang) )
	{
		$lang_entry_dst['key'][$num_entries_dst] = $key;
		$lang_entry_dst['value'][$num_entries_dst] = $value;
		$num_entries_dst++;
	}

	$missing = array();

	// Missing Language Variables
	for ($i = 0; $i < $num_entries_src; $i++)
	{
		if (!in_array($lang_entry_src['key'][$i], $lang_entry_dst['key']))
		{
			$missing['key'][] = $lang_entry_src['key'][$i];
			$missing['value'][] = $lang_entry_src['value'][$i];
		}
	}

	$not_needed = array();

	// Not anymore needed Lang Vars
	for ($i = 0; $i < $num_entries_dst; $i++)
	{
		if (!in_array($lang_entry_dst['key'][$i], $lang_entry_src['key']))
		{
			$not_needed['key'][] = $lang_entry_dst['key'][$i];
			$not_needed['value'][] = $lang_entry_dst['value'][$i];
		}
	}

	// Write down those Lang Vars
	print_r("<b>These Language Variables are <span style='color=#FF0000'>missing</span> from " . $dest_lang . "/lang_" . $file_var .".php</b><br />");
	for ($i = 0; $i < count($missing['key']); $i++)
	{
		print_r("<span class=\"gensmall\">\$lang['" . $missing['key'][$i] . "'] = '" . format_text($missing['value'][$i]) . "';</span><br />");
	}

	print_r("<br /><b>These Language Variables are <span style='color=#FF0000'>no longer needed</span> in " . $dest_lang . "/lang_" . $file_var .".php</b><br />");
	for ($i = 0; $i < count($not_needed['key']); $i++)
	{
		print_r("<span class=\"gensmall\">\$lang['" . $not_needed['key'][$i] . "'] = '" . format_text($not_needed['value'][$i]) . "';</span><br />");
	}
	print_r("</td></tr></table><br />");
}


$dir = opendir($dirname);

while ( $file = readdir($dir) )
{
	if ( ereg("^lang_", $file) && !ereg("^lang_english", $file) && !is_file($dirname . '/' . $file) && !is_link($dirname . '/' . $file) )
	{
compare_files('lang_english', $file, 'admin');
compare_files('lang_english', $file, 'admin_acronyms');
compare_files('lang_english', $file, 'admin_album');
compare_files('lang_english', $file, 'admin_attach');
compare_files('lang_english', $file, 'admin_attach_cp');
compare_files('lang_english', $file, 'admin_banner');
compare_files('lang_english', $file, 'admin_board');
compare_files('lang_english', $file, 'admin_clean');
compare_files('lang_english', $file, 'admin_cron');
compare_files('lang_english', $file, 'admin_db_utilities');
compare_files('lang_english', $file, 'admin_donors');
compare_files('lang_english', $file, 'admin_faq_editor');
compare_files('lang_english', $file, 'admin_forum_tour');
compare_files('lang_english', $file, 'admin_group_extend');
compare_files('lang_english', $file, 'admin_groups');
compare_files('lang_english', $file, 'admin_hacks_list');
compare_files('lang_english', $file, 'admin_link');
compare_files('lang_english', $file, 'admin_list');
compare_files('lang_english', $file, 'admin_mail_users');
compare_files('lang_english', $file, 'admin_mass_email');
compare_files('lang_english', $file, 'admin_pafiledb');
compare_files('lang_english', $file, 'admin_portal');
compare_files('lang_english', $file, 'admin_priv_msgs');
compare_files('lang_english', $file, 'admin_rebuild_search');
compare_files('lang_english', $file, 'admin_statistics');
compare_files('lang_english', $file, 'admin_topic_shadow');
compare_files('lang_english', $file, 'admin_userlist');
compare_files('lang_english', $file, 'admin_users');
compare_files('lang_english', $file, 'admin_wpm');
compare_files('lang_english', $file, 'banner');
compare_files('lang_english', $file, 'bbcode');
compare_files('lang_english', $file, 'bot_admin');
compare_files('lang_english', $file, 'card');
compare_files('lang_english', $file, 'chatbox');
compare_files('lang_english', $file, 'chatspot');
compare_files('lang_english', $file, 'clown_album');
compare_files('lang_english', $file, 'contact');
compare_files('lang_english', $file, 'contact_faq');
compare_files('lang_english', $file, 'dbmtnc');
compare_files('lang_english', $file, 'delayed_post');
compare_files('lang_english', $file, 'digest');
compare_files('lang_english', $file, 'donate_curreny');
compare_files('lang_english', $file, 'errors');
compare_files('lang_english', $file, 'extend');
compare_files('lang_english', $file, 'extend_announces');
compare_files('lang_english', $file, 'extend_categories_hierarchy');
compare_files('lang_english', $file, 'extend_group_moderatorz');
compare_files('lang_english', $file, 'extend_lang_extend');
compare_files('lang_english', $file, 'extend_last_topics_from');
compare_files('lang_english', $file, 'extend_merge');
compare_files('lang_english', $file, 'extend_meta_tags');
compare_files('lang_english', $file, 'extend_mods_settings');
compare_files('lang_english', $file, 'extend_pcp_addons');
compare_files('lang_english', $file, 'extend_pcp_management');
compare_files('lang_english', $file, 'extend_pcp_wiz');
compare_files('lang_english', $file, 'extend_points');
compare_files('lang_english', $file, 'extend_post_icons');
compare_files('lang_english', $file, 'extend_profile_control_panel');
compare_files('lang_english', $file, 'extend_qbar');
compare_files('lang_english', $file, 'extend_ranks');
compare_files('lang_english', $file, 'extend_split_topic_type');
compare_files('lang_english', $file, 'extend_sub_template');
compare_files('lang_english', $file, 'extend_topic_calendar');
compare_files('lang_english', $file, 'faq');
compare_files('lang_english', $file, 'faq_attach');
compare_files('lang_english', $file, 'ftr');
compare_files('lang_english', $file, 'groupcp');
compare_files('lang_english', $file, 'install');
compare_files('lang_english', $file, 'ipn_grp');
compare_files('lang_english', $file, 'ipsearch');
compare_files('lang_english', $file, 'jr_admin');
compare_files('lang_english', $file, 'kb');
compare_files('lang_english', $file, 'kbsearch');
compare_files('lang_english', $file, 'main');
compare_files('lang_english', $file, 'main_album');
compare_files('lang_english', $file, 'main_attach');
compare_files('lang_english', $file, 'main_link');
compare_files('lang_english', $file, 'main_mini_cal');
compare_files('lang_english', $file, 'modcp');
compare_files('lang_english', $file, 'multiple_album');
compare_files('lang_english', $file, 'mycookies');
compare_files('lang_english', $file, 'news');
compare_files('lang_english', $file, 'pafiledb');
compare_files('lang_english', $file, 'phpbbmyadmin');
compare_files('lang_english', $file, 'posting');
compare_files('lang_english', $file, 'postings_popup');
compare_files('lang_english', $file, 'prillian');
compare_files('lang_english', $file, 'prillian_faq');
compare_files('lang_english', $file, 'prillinstall');
compare_files('lang_english', $file, 'printertopic');
compare_files('lang_english', $file, 'prune_users');
compare_files('lang_english', $file, 'rating');
compare_files('lang_english', $file, 'rule');
compare_files('lang_english', $file, 'search');
compare_files('lang_english', $file, 'shoutbox');
compare_files('lang_english', $file, 'show_post');
compare_files('lang_english', $file, 'sig_control');
compare_files('lang_english', $file, 'smilies_upload');
compare_files('lang_english', $file, 'staff');
compare_files('lang_english', $file, 'statistics');
compare_files('lang_english', $file, 'tellafriend');
compare_files('lang_english', $file, 'tour');
compare_files('lang_english', $file, 'viewforum');
compare_files('lang_english', $file, 'viewonline');
compare_files('lang_english', $file, 'viewtopic');
compare_files('lang_english', $file, 'xs');	
	}
}

print_r("<div align='center' class='copyright'>Language Checker by <a href='http://www.opentools.de' target='_blank' class='copyright'>Acyd Burn</a> &copy; 2002, 2003<br />Modified for <a href='http://phpbbfm.net' target='_blank' class='copyright'>Fully Modded</a> by MJ &copy; 2003</div>");

?>